VERSION 5.00
Begin VB.Form frmGraficoRadici 
   BorderStyle     =   1  'Fixed Single
   Caption         =   " Grafico delle radici"
   ClientHeight    =   6690
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8475
   Icon            =   "frmGraficoRadici.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MDIChild        =   -1  'True
   ScaleHeight     =   6690
   ScaleWidth      =   8475
   Begin VB.CommandButton cmdChiudi 
      Caption         =   "&Chiudi"
      Height          =   255
      Left            =   7440
      TabIndex        =   1
      Top             =   6240
      Width           =   855
   End
   Begin VB.Frame frmLivelli 
      Caption         =   "Livelli  di |P(x)|"
      Height          =   5865
      Left            =   6120
      TabIndex        =   7
      Top             =   150
      Width           =   2175
      Begin VB.CheckBox chkScriviValori 
         Alignment       =   1  'Right Justify
         Caption         =   "Scrivi valori"
         Height          =   255
         Left            =   180
         TabIndex        =   10
         Top             =   5520
         Width           =   1155
      End
      Begin VB.CommandButton cmdLivelli 
         Height          =   255
         Left            =   1560
         Picture         =   "frmGraficoRadici.frx":0442
         Style           =   1  'Graphical
         TabIndex        =   0
         ToolTipText     =   "Disegna i Livelli "
         Top             =   5520
         Width           =   465
      End
      Begin VB.Label lblLivello 
         BackStyle       =   0  'Transparent
         Caption         =   "--.---E00"
         Height          =   195
         Index           =   0
         Left            =   1080
         TabIndex        =   9
         Top             =   5070
         Visible         =   0   'False
         Width           =   975
      End
      Begin VB.Label lblLivelloCol 
         Appearance      =   0  'Flat
         BackColor       =   &H80000005&
         BorderStyle     =   1  'Fixed Single
         ForeColor       =   &H80000008&
         Height          =   135
         Index           =   0
         Left            =   240
         TabIndex        =   8
         Top             =   5100
         Visible         =   0   'False
         Width           =   735
      End
   End
   Begin VB.PictureBox picRadici 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      Height          =   5775
      Left            =   240
      MousePointer    =   2  'Cross
      ScaleHeight     =   5715
      ScaleWidth      =   5715
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   240
      Width           =   5775
   End
   Begin VB.Label lblModFxCurPos 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   5040
      TabIndex        =   12
      Top             =   6240
      Width           =   960
   End
   Begin VB.Label Label1 
      BackStyle       =   0  'Transparent
      Caption         =   "|P(x)|:"
      Height          =   255
      Left            =   4620
      TabIndex        =   11
      Top             =   6240
      Width           =   435
   End
   Begin VB.Label zLabel02 
      BackStyle       =   0  'Transparent
      Caption         =   "P(x):"
      Height          =   255
      Left            =   2160
      TabIndex        =   6
      Top             =   6240
      Width           =   375
   End
   Begin VB.Label zLabel01 
      BackStyle       =   0  'Transparent
      Caption         =   "x:"
      Height          =   255
      Left            =   240
      TabIndex        =   5
      Top             =   6240
      Width           =   255
   End
   Begin VB.Label lblFxCurPos 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   2520
      TabIndex        =   4
      Top             =   6240
      Width           =   1935
   End
   Begin VB.Label lblCurPos 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   420
      TabIndex        =   3
      Top             =   6240
      Width           =   1575
   End
End
Attribute VB_Name = "frmGraficoRadici"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'=============================================================
' Descrizione.....: Form per disegnare, sul piano complesso,
'                   le radici dei polinomi.
' Nome dei Files..: frmGraficoRadici.frm, frmGraficoRadici.frx
'                   modPoliRad.bas, modUtilita.bas,
'                   Complex.bas, Livelli.bas
' Data............: 15/2/2000
' Aggiornamento...: 22/7/2001
' Versione........: 1.1 a 32 bits.
' Sistema.........: VB6 sotto Windows NT.
' Scritto da......: F. Languasco 
' E-Mail..........: MC7061@mclink.it
' DownLoads a.....: http://members.xoom.it/flanguasco/
'                   http://www.mclink.it/personal/MC7061/
'=============================================================
'
'   Routine di ingresso: Apri
'
Option Explicit
'
Dim Np&                 ' N di coefficienti del polinomio.
Dim aN1() As Complex    ' Vettore dei coefficienti, complessi, del polinomio.
Dim Xn() As Complex     ' Vettore delle radici, complesse, del polinomio.
'
Dim ReMin#, ReMax#      ' Estremi del quadro.
Dim ImMin#, ImMax#      '
'
Const DGriglia& = 50    ' Risoluzione della griglia
                        ' dei livelli.
Const MaxNL& = 15       ' N. di linee di livello.
'
Dim fStop As Boolean    ' Flag di interruzione del disegno dei livelli.
Dim fLivelli As Boolean ' Flag di livelli tracciati.
'
Const PCHL& = &HC0FFFF  ' Colore di evidenza per le etichette di Posizione cursore.
'
Const Me_W& = 8565      ' Dimensioni di questo
Const Me_H& = 7065      ' Form [Twips].

Friend Sub Apri(xN_I() As Complex, aN1_I() As Complex)
'
'
    Xn() = xN_I()   ' Radici del polinomio.
    aN1() = aN1_I() ' Coefficienti del polinomio.
    Np = UBound(Xn) ' N di coefficienti del polinomio.
'
    Me.WindowState = vbNormal
    Me.ZOrder vbBringToFront
    Me.Show
'
    DisegnaRadici
'
'
'
End Sub

Private Sub MinMax()
'
'   Trova gli estremi di scala reale ed immaginaria:
'
    Dim I&
'
    ReMin = Xn(1).re
    ReMax = Xn(1).re
    ImMin = Xn(1).im
    ImMax = Xn(1).im
'
    For I = 2 To Np
        If ReMin > Xn(I).re Then ReMin = Xn(I).re
        If ReMax < Xn(I).re Then ReMax = Xn(I).re
        If ImMin > Xn(I).im Then ImMin = Xn(I).im
        If ImMax < Xn(I).im Then ImMax = Xn(I).im
    Next I
'
    ReMin = Int(ReMin - 0.1)
    ReMax = Ceil(ReMax + 0.1)
'
    ImMin = Int(ImMin - 0.1)
    ImMax = Ceil(ImMax + 0.1)
'
'
'
End Sub

Private Sub chkScriviValori_Click()
'
'
    If fLivelli Then DisegnaLivelli
'
'
'
End Sub

Private Sub cmdChiudi_Click()
'
'
    Unload Me
'
'
'
End Sub

Private Sub cmdLivelli_Click()
'
'
    fLivelli = Not fLivelli
    cmdLivelli.Caption = IIf(fLivelli, "             Canc", "")
    cmdLivelli.ToolTipText = IIf(fLivelli, "Cancella i Livelli ", "Disegna i Livelli ")
'
    VediLivelli fLivelli
    DisegnaLivelli
'
'
'
End Sub

Private Sub DisegnaLivelli()
'
'
    Dim I&, J&, K&, sDRe!, sDIm!, Msg$
    Dim DMin!, DMax!, BaseL!, LStile&
    Dim xPc As Complex, FxPc As Complex
    Dim RD!(0 To DGriglia, 0 To DGriglia)
    Dim RX!(0 To DGriglia), RY!(0 To DGriglia)
    Dim Rz!(0 To MaxNL - 1)
'
    picRadici.Cls
'
    If Not fLivelli Then Exit Sub
'
    ' Dati delle curve di livello:
    sDRe = (ReMax - ReMin) / CSng(DGriglia)
    sDIm = (ImMax - ImMin) / CSng(DGriglia)
    DMin = 1E+38
    DMax = -1E+38
    For I = 0 To DGriglia
        RX(I) = ReMin + CSng(I) * sDRe
        For J = 0 To DGriglia
            RY(J) = ImMin + CSng(J) * sDIm
            xPc = CCmp(RX(I), RY(J))
            FxPc = CCPoliVal(xPc, aN1())
            RD(I, J) = CAbs(FxPc)
            If DMin > RD(I, J) Then DMin = RD(I, J)
            If DMax < RD(I, J) Then DMax = RD(I, J)
        Next J
    Next I
    DMax = DMax - DMax / 10!    ' Permette di vedere il livello DMax.
'
    LStile = 2  ' Sceglie la spaziatura fra
                ' le linee di livello.
    Select Case LStile
        Case 1
        BaseL = (DMax - DMin) / (CSng(Np) ^ (MaxNL - 1))
        For K = 0 To MaxNL - 1
            Rz(K) = DMin + BaseL * CSng(Np) ^ K
            lblLivello(K).Caption = Format$(Rz(K), "0.000E-00")
        Next K
'
        Case 2
        BaseL = 3
        For K = 0 To MaxNL - 1
            Rz(K) = DMin _
            + (BaseL ^ (CSng(K)) - 1!) * (DMax - DMin) / (BaseL ^ (MaxNL - 1) - 1!)
            lblLivello(K).Caption = Format$(Rz(K), "0.000E-00")
        Next K
    End Select
'
    ' Disegno dei livelli della superficie:
    fStop = False
    CONREC picRadici, RD(), RX(), RY(), Rz(), Msg$ _
         , (chkScriviValori.Value = vbChecked), , fStop
    If Msg$ <> "" Then MsgBox Msg$, , " CONREC"
'
'
'
End Sub

Private Sub DisegnaRadici()
'
'   Disegna le radici del polinomio sul piano complesso.
'   Se una radice e' multipla, di ordine Mrt, disegna
'   Mrt cerchi concentrici.
'   Nota: a causa degli errori di arrotondamento, inevitabili
'   nei calcoli di ricerca delle radici, e' impossibile dire,
'   conoscendone solo il valore, se due radici siano o no
'   coincidenti. In questa routine si e' scelto di considerare
'   coincidenti radici con distanza < Eps, con Eps determinato
'   in modo tale da disegnare con cerchi concentrici tutte quelle
'   radici la cui distanza e' < di 2 Pixels.
'
    Dim I&, J&, K&, r3Px!, qrd#, EpsQ#
    ReDim Mrt&(1 To Np, 1 To 2) ' Dimensione 1; N della radice.
                                ' Dimensione 2; 1: se = 1 la radice non viene disegnata.
                                ' Dimensione 2; 2: molteplicita' della radice.
'
    picRadici.Picture = LoadPicture("")
'
    ' Trova gli estremi di scala:
    MinMax
    ' Disegna il quadro:
    Quadro picRadici, ReMin, ReMax, ImMin, ImMax _
          , , , 3, r3Px, , "Radici nel piano complesso", "Re", "Im", True
    EpsQ = (2# * r3Px / 3#) ^ 2
'
    ' Individua le radici multiple ed all' interno
    ' del cerchio di raggio eps:
    For I = 1 To Np
        If Mrt(I, 1) = 0 Then       ' La radice Ima non e' ancora
                                    ' stata trovata.
'
            Mrt(I, 2) = 1           ' La radice Ima verra' disegnata
                                    ' almeno una volta.
'
            For J = I + 1 To Np
                ' Calcolo la distanza della radice Ima dalla radice Jma:
                qrd = (Xn(I).re - Xn(J).re) ^ 2 + (Xn(I).im - Xn(J).im) ^ 2
                If qrd < EpsQ Then
                    Mrt(J, 1) = 1               ' La distanza e' < Eps e la radice
                                                ' Jma non verra' disegnata.
'
                    Mrt(I, 2) = Mrt(I, 2) + 1   ' La radice Ima verra' disegnata
                                                ' Mrt(I, 2) volte.
                End If
            Next J
        End If
    Next I
'
    ' Disegna le radici:
    For I = 1 To Np
        If Mrt(I, 1) = 0 Then
            ' La radice Ima non e' stata scartata:
            For K = 1 To Mrt(I, 2)
                ' e deve essere disegnata Mrt(I, 2) volte:
                picRadici.Circle (Xn(I).re, Xn(I).im), CSng(K) * r3Px, vbRed
            Next K
        End If
    Next I
'
    picRadici.AutoRedraw = False
'
'
'
End Sub

Private Sub Form_Load()
'
'
    Dim K&, Me_L&, Me_T&
'
    LeggiPosizioneForm Me, Me_L, Me_T
    Me.Move Me_L, Me_T, Me_W, Me_H
'
    lblLivelloCol(0).BackColor = QBColor(1)
    For K = 1 To MaxNL - 1
        Load lblLivello(K)
        lblLivello(K).Top = lblLivello(K - 1).Top - 330
        lblLivello(K).Caption = lblLivello(K - 1).Caption
'
        Load lblLivelloCol(K)
        lblLivelloCol(K).Top = lblLivelloCol(K - 1).Top - 330
        lblLivelloCol(K).BackColor = QBColor(K + 1)
    Next K
'
'
'
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
'
'
    AggiornaPosizioniCursore "", "", ""
'
'
'
End Sub

Private Sub Form_Paint()
'
'
    If fLivelli Then DisegnaLivelli
'
'
'
End Sub

Private Sub Form_Unload(Cancel As Integer)
'
'
    fStop = True
'
    SalvaPosizioneForm Me
    Set frmGraficoRadici = Nothing
'
'
'
End Sub

Private Sub frmLivelli_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
'
'
    AggiornaPosizioniCursore "", "", ""
'
'
'
End Sub


Private Sub picRadici_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
'
'
    Dim xPc As Complex, FxPc As Complex
'
    xPc = CCmp(X, Y)
    FxPc = CCPoliVal(xPc, aN1())
'
    AggiornaPosizioniCursore CFormat$(xPc, "#0.###", 8) _
                           , CFormat$(FxPc, "#0.###", 8) _
                           , Format$(CAbs(FxPc), "0.000E-00")
'
'
'
End Sub
Private Sub AggiornaPosizioniCursore(ByVal sVal1$, ByVal sVal2$, ByVal sVal3$)
'
'   Aggiorna i valori delle finestrelle di posizione
'   del cursore ed imposta il colore di evidenziazione:
'
    lblCurPos = sVal1$
    lblFxCurPos = sVal2$
    lblModFxCurPos = sVal3$
'
    lblCurPos.BackColor = IIf(sVal1$ = "", vbButtonFace, PCHL)
    lblFxCurPos.BackColor = IIf(sVal2$ = "", vbButtonFace, PCHL)
    lblModFxCurPos.BackColor = IIf(sVal3$ = "", vbButtonFace, PCHL)
'
'
'
End Sub



Private Sub VediLivelli(ByVal bVisibili As Boolean)
'
'   Mostra o nasconde i colori ed i valori
'   delle linee di livello:
'
    Dim K&
'
    For K = 0 To MaxNL - 1
        lblLivello(K).Visible = bVisibili
        lblLivelloCol(K).Visible = bVisibili
    Next K
'
'
'
End Sub
